Global( "EVRe", {} )
--------
function Reg (ER)
for k, v in pairs(ER) do
	if string.find(k, "[A-Z]+T_+[A-Z]") then
		common.RegisterEventHandler(v, k)
	else
		common.RegisterReactionHandler(v, k)
	end
end
end

--EVENTS
EVRe["SCRIPT_ADDON_INFO_REQUEST"] = function(params)
if params.target == common.GetAddonName() then
	userMods.SendEvent( "SCRIPT_ADDON_INFO_RESPONSE", {
		sender = params.target,
		desc = common.GetAddonName().." v."..tostring(revision).." ["..rdate.."/Nikon]",
		showDNDButton = false
		--showHideButton  = false,
		--showSettingsButton = false
		--addonsBlocked = {}
	})
end
end

EVRe["U_EVENT_ADDON_MEM_USAGE_REQUEST"] = function(params)
userMods.SendEvent( "U_EVENT_ADDON_MEM_USAGE_RESPONSE", {sender = common.GetAddonName(), memUsage = gcinfo()})
end

EVRe["EVENT_HEALING_RECEIVED"] = function(params)
if Battle.cnf.freeze then return end
if Battle.bin or Battle.dmge then
	AddData (params)
end
end

EVRe["EVENT_UNIT_DAMAGE_RECEIVED"] = function(params)
--common.LogInfo(common.GetAddonName(),"EVENT_UNIT_DAMAGE_RECEIVED")

--for p,v in params do
--common.LogInfo("",tostring(p)," - ", tostring(v))
--end


if Battle.cnf.freeze then return end
if Battle.bin or Battle.dmge then
	--common.LogInfo("","AddData ",tostring(params.amount))
	AddData (params)
else
	while Battle.lastp[3] do table.remove(Battle.lastp,1) end
	table.insert(Battle.lastp,params)
end
end

EVRe["EVENT_AVATAR_COMBAT_STATUS_CHANGED"] = function(params)
--common.LogInfo(common.GetAddonName(),"COMBAT_STATUS_CHANGED ",tostring(params.inCombat))
if Battle.cnf.freeze then
	Battle.bin,Battle.dmge = false,false
	Slp:SetVariant(params.inCombat and 3 or 2)
	return
end
if Battle.inbuild then 
if not Battle.bin and params.inCombat then
	Slp:SetVariant(3)
	StartFigth()
	PMain[3]:FinishFadeEffect()
	PMain[3]:SetFade(1)
	PMain[1]:SetFormat(StForm[2])
	PMain[1]:SetVal("Min", Format02d(0))
	PMain[1]:SetVal("Sec", Format02d(0))
	--PMain[1]:SetVal("Pos", Format02d(1))
	--PMain[1]:SetVal("DPS", Format45d(0))
	--common.LogInfo("","StartFigth() ")
	if Battle.lastp[1] then
		for v,t in Battle.lastp do
			if not t.lethal then AddData(t) end
		end
		Battle.lastp = {}
	end
elseif params.inCombat then
	common.LogInfo("","inCombat lastp ", tostring(table.getn(Battle.lastp)))
	if Battle.lastp[1] then
		for v,t in Battle.lastp do
			--if not t.lethal then AddData(t) end
			AddData(t)
		end
		Battle.lastp = {}
	end
	--common.LogInfo("","Repeat_inCombat!!")
	--common.LogInfo("","CurFight.ftime - ", Format02d(CurFight.ftime))
--elseif Battle.inbuild then
else
	--common.LogInfo("","else...",tostring(Battle.inbuild))
	Battle.inbuild = false
	Slp:PlayFadeEffect(1,0.2,WTime,EA_MONOTONOUS_INCREASE)
end
end
Battle.bin = params.inCombat
end

EVRe["EVENT_SECOND_TIMER"] = function(params)
if Battle.cnf.freeze then return end

--[[if Battle.fadeTime < 1e5 and Battle.fadeTime > FadeTime then
	common.LogInfo("","Battle.fadeTime ", tostring(Battle.fadeTime))
	PM:GetChildUnchecked("PanelM", false):SetFade(0)
	Battle.fadeTime = 1e6
else Battle.fadeTime = Battle.fadeTime + 1 end]]

if Battle.dmge then
	CurFight.ftime = CurFight.ftime + params.elapsedMs
	if Battle.ref > 1 then
		Battle.ref = Battle.ref - 1
	else
		Battle.ref = VRefresh
		RefrVisData ()
	end
	
	if Battle.tref > 1 then
		Battle.tref = Battle.tref - 1
	else
		Battle.tref = TRefresh
		AddTickDPS()
		RefrGraph()
	end
end
end

EVRe["EVENT_AVATAR_CREATED"] = function(params)
Lang = SetAddonLoc(Lang)
CreateWidgets()
SetColors()
--stateMainForm:GetChildUnchecked("ContextBag",false):AddChild(mainForm)
SetMyParents()
Slp:SetVariant(2)
DnDInit()
DataInit()
end

EVRe["EVENT_EFFECT_FINISHED"] = function(params)
--if params.effectType == ET_FADE and params.wtOwner:GetName() == "BtnFreeze" then
if params.effectType == ET_FADE then
	if params.wtOwner:GetName() == "BtnFreeze" then
		Battle.inbuild = true
		--Slp:SetVariant(2)
		--Slp:SetFade(1)
		--if Battle.bin then return end
		if unit.IsInCombat(Battle.avaid) then return end
		if Battle.lastp[1] then
			for v,t in Battle.lastp do AddData(t) end
			Battle.lastp = {}
			--common.LogInfo("","Battle.lastp = {}")
		end
		if CurFight.fName then
			--common.LogInfo("","CurFight.ftime = ", tostring(CurFight.ftime))
			IF()
			RefrVisData()
			--SaveFightincfg()
		end
		PMain[1]:SetFormat(StForm[1])
		PMain[1]:SetVal("Name", GetTextLocalized(GetVisMode()))
		Battle.bin,Battle.dmge = false,false
		Slp:SetVariant(2)
		Slp:SetFade(1)
		
		PMain[3]:PlayFadeEffect(1,0,10e3,EA_MONOTONOUS_INCREASE)
	--elseif params.wtOwner:GetName() == "BtnFreeze" then
		
		
		
		
	end
end
end

--REACTIONS
EVRe["btn_UpDown"] = function(reaction)
--reaction.widget:GetParent():SetFade(0.0)
if reaction.widget:GetVariant() == 0 then
	reaction.widget:SetVariant(1)
	PM:GetChildUnchecked("PanelGroup", false):Show(true)
	RefrVisData()
else
	reaction.widget:SetVariant(0)
	PM:GetChildUnchecked("PanelGroup", false):Show(false)
end
Battle.cnf.gropened = PM:GetChildUnchecked("PanelGroup", false):IsVisible()
Config(true)
end

EVRe["btn_Detail"] = function(reaction)
if DnD.IsPicked then return end
local wdt = reaction.widget:GetParent():GetParent()
--common.LogInfo(common.GetAddonName(),"btn_Detail")
if wdt:GetName() == "PanelDetail" then wdt:Show(false)
elseif Fights[1] then
	wdt = mainForm:GetChildUnchecked("PanelDetail", false)
	wdt:Show(not wdt:IsVisible())
	wdt = wdt:GetChildUnchecked("TextAddon", false)
	wdt:SetVal("Hist", Format02d(table.getn(Fights)))
	wdt:SetVal("Max", Format02d(MaxHistory))
	wdt:SetVal("Name", userMods.ToWString(common.GetAddonName()))
	wdt:SetVal("rdate", userMods.ToWString(rdate))
	wdt:SetVal("rev", Format02d(revision))
	wdt:SetVal("memo", Format45d(gcinfo()*1e3))
	if Battle.cnf.fighis then PlaceFights(1)
	else PlaceFighters ()
	end
	Menu[2]:Show(false)
	Menu[1]:Show(false)
end
end

EVRe["btn_Nil"] = function(reaction)
if reaction.widget:GetParent():GetName() == "PanelHeader" then
	local  hm = GetHisMode()
	if not Menu[1]:IsVisible() then
		for u,t in Menu[1]:GetNamedChildren() do
			t:SetVariant(t:GetName() == hm and 1 or 0)
		end
	end
	Menu[1]:Show(not Menu[1]:IsVisible())
else
	local hm = GetVisMode()
	if not Menu[2]:IsVisible() then
		for u,t in Menu[2]:GetNamedChildren() do
			t:SetVariant(t:GetName() == hm and 1 or 0)
		end
	end
	Menu[2]:Show(not Menu[2]:IsVisible())
end
end

EVRe["btn_DNil"] = function(reaction)
if string.find(reaction.sender, "BtnDU_") then
	PlaceFighters(tonumber(string.sub (reaction.sender,7)))
elseif string.find(reaction.sender, "BtnD_") then
	if not Battle.cnf.fighis then
		PlaceFights (tonumber(string.sub (reaction.sender,6)))
	end
	PlaceSpells(tonumber(string.sub (reaction.sender,6)))
elseif string.find(reaction.sender, "BtnFD_") then
	PlaceTimes(tonumber(string.sub (reaction.sender,7)))
end
end

EVRe["btn_Freeze"] = function(reaction)
--common.LogInfo("","btn_Freeze ", reaction.sender)
if DnD.IsPicked then return end
GoSleep (not Battle.cnf.freeze)
end

EVRe["PS_op"] = function(reaction)
if string.find(reaction.sender, "PnlS_") then
	PlaceSDetail(tonumber(string.sub (reaction.sender,6)))
end
end

EVRe["UD_rclk"] = function(reaction)
local wdt = mainForm:GetChildUnchecked("PanelGraph", false)
Battle.cnf.grph = not wdt:IsVisible()
wdt:Show(Battle.cnf.grph)
RefrGraph(Battle.cnf.grph)
Config (true)
end

EVRe["btn_Selct"] = function(reaction)
--common.LogInfo(common.GetAddonName(),"btn_Selct", reaction.sender)
Menu[1]:Show(false)
Menu[2]:Show(false)
end

EVRe["btn_unSelct"] = function(reaction)
if reaction.widget:GetParent():GetName() == "CFMenu" then
	if reaction.sender == "Reset" then
		mainForm:GetChildUnchecked("PanelDetail", false):Show(false)
		Resetdata ()
	elseif reaction.sender ~= "Lne" then
		SetVisMode (reaction.sender)
		Config(true)
	end
else
	if string.find(reaction.sender, "Reset") then
		mainForm:GetChildUnchecked("PanelDetail", false):Show(false)
		Resetdata ()
	elseif reaction.sender ~= "Lne" then
		SetHisMode (reaction.sender)
		if Battle.cnf.fighis then PlaceFights(1)
		else PlaceFighters ()
		end
		Config(true)
		--common.LogInfo(common.GetAddonName(), Format45d(GetHisMode()))
	end
end
Menu[1]:Show(false)
Menu[2]:Show(false)
RefrVisData()
RefrGraph(true)
end

EVRe["panel_over"] = function(reaction)
--common.LogInfo(common.GetAddonName(),"panel_over ", reaction.sender)
end